﻿BINDING_HEADER_IGUARD = "I Guard";
BINDING_NAME_IG_INCOMMING1 = "One Enemy";
BINDING_NAME_IG_INCOMMING2 = "Two Enemies";
BINDING_NAME_IG_INCOMMING3 = "Three Enemies";
BINDING_NAME_IG_INCOMMING4 = "Four Enemies";
BINDING_NAME_IG_ZERG = "Enemy Zerg";
BINDING_NAME_IG_SAFE = "Call it Safe";
BINDING_NAME_IG_CCD = "Im Crowd Controlled";

function IG_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
end
function IG_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		IG_ChatMessage("IGuard v0.6.5v2 loaded. Type |c00FFFFFF/IGuard|r to display options.");
		IG_ChatMessage("Remember to set up your Key Bindings.");
		
		IGuardRecheck();
		
		SlashCmdList["IGuardCOMMAND"] = IGuardSlashHandler;
		  SLASH_IGuardCOMMAND1 = "/IGuard";
		SlashCmdList["IGuardRaidCOMMAND"] = IGuardRaidSlashHandler;
		  SLASH_IGuardRaidCOMMAND1 = "/IGuardRaid";
		  SLASH_IGuardRaidCOMMAND2 = "/IGR";
		SlashCmdList["IGuardSoloCOMMAND"] = IGuardSoloSlashHandler;
		  SLASH_IGuardSoloCOMMAND1 = "/IGuardSolo";
		  SLASH_IGuardSoloCOMMAND2 = "/IGS";
		SlashCmdList["IGuardPartyCOMMAND"] = IGuardPartySlashHandler;
		  SLASH_IGuardPartyCOMMAND1 = "/IGuardParty";
		  SLASH_IGuardPartyCOMMAND2 = "/IGP";
		  
		if (IG_RAIDCHANNEL == nil) then
			IG_RAIDCHANNEL = "RAID";
			IG_PARTYCHANNEL = "PARTY";
			IG_SAYCHANNEL = "SAY";
		end
		
		if (IGuardEnabled == nil) then
			IGuardEnabled = true;
			IGHelpEnabled = true;
		end
	end

end

function IGHelpText()
	if (IGHelpEnabled == true) then
		return ", Help if possible.";
	else
		return ".";
	end
end

function IG_Afflicted() 
local i=1;
	while(UnitDebuff("player",i)) do 
		if(string.find(UnitDebuff("player",i),"Sap")) then 
			return "Sapped!";
		elseif (string.find(UnitDebuff("player",i),"Seduction")) then
			return "Charmed!";
		elseif (string.find(UnitDebuff("player",i),"Polymorph")) then
			return "Polymophed!";
		end;
		i=i+1;	
	end;
	return "Unknown CC";
end

function IGuardRecheck()
	if (UnitFactionGroup("player") == "Horde") then
		IG_Language = "Orcish";
		IG_Enemy = "Alliance";
	elseif (UnitFactionGroup("player") == "Alliance") then
		IG_Language = "Common";
		IG_Enemy = "Horde";
	else
		IG_Language = nil;
		IG_Enemy = "Enemy";
	end	
	IG_ChatMessage("Enemy set to " .. IG_Enemy);
end 

function IG_ChatMessage(msg)
	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("- IGuard: "..msg ,0.8, 0.8, 0.3);
	end
end
function IG_ChannelType(msg,arg1)
	if (msg == "RAID") then
		IG_RAIDCHANNEL = arg1;
	elseif (msg == "PARTY") then
		IG_PARTYCHANNEL = arg1;
	elseif (msg == "SAY") then
		IG_SAYCHANNEL = arg1;
	elseif (msg == "DEFAULT") then
		IG_RAIDCHANNEL = "RAID";
		IG_PARTYCHANNEL = "PARTY";
		IG_SAYCHANNEL = "SAY";
		IG_ChatMessage("Channels reseted")
	else
	IG_ChatMessage("Error: Failed to change Channel type.")
	end
end
function IG_Bindings(msg)
	if ( GetNumPartyMembers() == 0) then
		if ( IG_CHANNEL == IG_PARTYCHANNEL or  IG_CHANNEL == IG_RAIDCHANNEL )then
		IG_ChatMessage("|c00FFFFFFReport Channel adjusted to:|r Solo Mode");
		IG_CHANNEL = IG_SAYCHANNEL;
		else
		IG_CHANNEL = IG_SAYCHANNEL;
		end
	elseif ( GetNumPartyMembers() >= 0 and UnitInRaid("player") == nil) then
		if (  IG_CHANNEL == IG_SAYCHANNEL or  IG_CHANNEL == IG_RAIDCHANNEL ) then
		IG_ChatMessage(" |c00FFFFFFReport Channel adjusted to:|r Group Mode");
		IG_CHANNEL = IG_PARTYCHANNEL;
		else
		IG_CHANNEL = IG_PARTYCHANNEL;
		end
	elseif (GetNumPartyMembers() >= 0 and UnitInRaid("player") == 1) then
		if (  IG_CHANNEL == IG_PARTYCHANNEL or  IG_CHANNEL == IG_SAYCHANNEL  ) then
		IG_ChatMessage(" |c00FFFFFFReport Channel adjusted to:|r Raid Mode");
		IG_CHANNEL = IG_RAIDCHANNEL;
		else
		IG_CHANNEL = IG_RAIDCHANNEL;
		end
	end
	if (IGuardEnabled == false) then
		msg = "disable";
	end
	if (msg == "disable") then
		IG_ChatMessage("Currently Disabled.")
	elseif (msg == 1) then
		IG_Reporter("One "..IG_Enemy.." at "..GetMinimapZoneText()..""..IGHelpText())	
	elseif (msg == 2) then
		IG_Reporter("Two "..IG_Enemy.." at "..GetMinimapZoneText()..""..IGHelpText())
	elseif (msg == 3) then
		IG_Reporter("Three "..IG_Enemy.." at "..GetMinimapZoneText()..""..IGHelpText())
	elseif (msg == 4) then
		IG_Reporter("Four "..IG_Enemy.." at "..GetMinimapZoneText()..""..IGHelpText())
	elseif (msg == 5) then
		IG_Reporter(IG_Enemy.." ZERG at "..GetMinimapZoneText()..""..IGHelpText())
	elseif (msg == 6) then
		IG_Reporter(GetMinimapZoneText().." is safe, "..IG_Enemy.." is dead.")
	elseif (msg == 7) then
		IG_Reporter(" Im "..IG_Afflicted()..", "..GetMinimapZoneText().." IS NOT SAFE.")
	else
	IG_ChatMessage("Error")
	end
end
function IG_Reporter(msg)
	if (IG_CTRA_ENABLE == nil ) then
		IG_CTRA_ENABLE = false;
	end
	if (IG_CHANNEL == "GENERAL" or IG_CHANNEL == "LOCALDEFENSE") then
		local mapZone = GetRealZoneText();
		local index = GetChannelName(IG_CHANNEL.." - "..mapZone);
		if (not index ~= nil) then
		SendChatMessage("IGuard: " .. msg,"CHANNEL",IG_Language,index); 
		end
	elseif ( IG_CTRA_ENABLE == true and IG_CHANNEL == "RAID") then
		if ( CT_RA_Level >= 1 ) then
			CT_RA_AddMessage("MS " .. msg);
			SendChatMessage("IGuard: ".. msg,IG_CHANNEL);
		else
			IG_ChatMessage("You must be Promoted or Leader for CT_RA /RS to work.");
			IG_ChatMessage("RA Support Disabled, use /IGuard CTRA to enable again");
			SendChatMessage("IGuard: ".. msg,IG_CHANNEL);
			IG_CTRA_ENABLE = false;
		end
	elseif ( IG_CTRA_ENABLE == false and IG_CHANNEL == "RAID") then
		SendChatMessage("IGuard: " .. msg,IG_CHANNEL)
	else
		SendChatMessage("IGuard: " .. msg,IG_CHANNEL)
	end
end
function IGuardRaidSlashHandler(msg)
	if (msg ~= nil) then
		local text = "Valid Channals:\n";
		local text = text .. "- IGuard: LocalDefense, General, Raid, Party, Guild\n";
		IG_ChatMessage(text);
	elseif (string.upper(msg) == "LOCALDEFENSE")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Raid Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("RAID",string.upper(msg));
	elseif (string.upper(msg) ==  "RAID")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Raid Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("RAID",string.upper(msg));
	elseif (string.upper(msg) ==  "PARTY")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Raid Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("RAID",string.upper(msg));
	elseif (string.upper(msg) ==  "GUILD")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Raid Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("RAID",string.upper(msg));
	elseif (string.upper(msg) == "GENERAL") then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Raid Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("RAID",string.upper(msg));
	else
		local text = "Invalid Channel\n";
		local text = text .. "- IGuard: use /IGuardRaid or /IGR to se Valid channels\n";
		IG_ChatMessage(text);
	end
end
function IGuardPartySlashHandler(msg)
	if (msg == nil or msg == "") then
		local text = "Valid Channals:\n";
		local text = text .. "- IGuard: LocalDefense, General, Party, Guild\n";
		IG_ChatMessage(text);
	elseif (string.upper(msg) == "LOCALDEFENSE")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("PARTY",string.upper(msg));
	elseif (string.upper(msg) ==  "PARTY")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("PARTY",string.upper(msg));
	elseif (string.upper(msg) ==  "GUILD")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("PARTY",string.upper(msg));
	elseif (string.upper(msg) == "GENERAL") then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Group Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("PARTY",string.upper(msg));
	else
		local text = "Invalid Channel\n";
		local text = text .. "- IGuard: use /IGuardParty or /IGP to se Valid channels\n";
		IG_ChatMessage(text);
	end
end
function IGuardSoloSlashHandler(msg)
	if (msg == nil or msg == "") then
		local text = "Valid Channals:\n";
		local text = text .. "- IGuard: LocalDefense, General, Guild, Say\n";
		IG_ChatMessage(text);
	elseif (string.upper(msg) == "LOCALDEFENSE")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Solo Mode Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("SAY",string.upper(msg));
	elseif (string.upper(msg) ==  "SAY")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Solo Mode Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("SAY",string.upper(msg));
	elseif (string.upper(msg) ==  "GUILD")  then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Solo Mode Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("SAY",string.upper(msg));
	elseif (string.upper(msg) == "GENERAL") then
		local text = "Valid Channel\n";
		local text = text .. "- IGuard: Solo Mode Channel Set to "..msg.."\n";
		IG_ChatMessage(text);
		IG_ChannelType("SAY",string.upper(msg));
	else
		local text = "Invalid Channel\n";
		local text = text .. "- IGuard: use /IGuardSolo or /IGS to se Valid channels\n";
		IG_ChatMessage(text);
	end
end

function IGuardSlashHandler(msg)
	if (msg == nil) then 
		IGuardStatus();
	elseif string.lower(msg) == "enable" then
		ToggleIGuard(1);
	elseif string.lower(msg) == "disable" then
		ToggleIGuard(0);
	elseif string.lower(msg) == "helpme" then
		if (IGHelpEnabled == false) then 
			IG_HelpMe(1);
		else
			IG_HelpMe(0);
		end
	elseif string.lower(msg) == "ctra" then
		IG_CTRA();
	elseif string.lower(msg) == "status" then
		IGuardStatusReport();
	elseif string.lower(msg) == "recheck" then
		IGuardRecheck();
	elseif string.lower(msg) == "reset" then
		IG_ChannelType("DEFAULT");
	elseif string.lower(msg) == "options" then
		IGuardFrame:Show()
	else
		IGuardStatus();
	end
end 
function IGuardStatusReport()
	IGuardRecheck();
	local text = "Language set to: |c00FFFFFF" .. IG_Language .. "|r\n";
	if (IGuardEnabled == true) then
		IGStatus = "- IGuard: |c00FFFFFFCurrent Status:|r Enabled.\n";
	else
		IGStatus = "- IGuard: |c00FFFFFFCurrent Status:|r Disabled.\n";
	end
	if (IGHelpEnabled == true) then
		IGHelp = "- IGuard: |c00FFFFFFHelp if Possible Enabled.|r\n";
	else
		IGHelp = "- IGuard: |c00FFFFFFHelp if Possible Disabled.|r\n";   
	end
	if (IG_CTRA_ENABLE == true) then
		IGCTRA = "- IGuard: |c00FFFFFF/rs Reporting Enabled.|r\n";
	else
		IGCTRA = "- IGuard: |c00FFFFFF/rs Reporting Disabled.|r\n";   
	end
	local text = text .. IGHelp
	local text = text .. IGStatus
	local text = text .. IGCTRA
	local text = text .. "- IGuard: " .. IG_RAIDCHANNEL .. " In Raid Group\n";
	local text = text .. "- IGuard: " .. IG_PARTYCHANNEL .. " In Regular Groups\n";
	local text = text .. "- IGuard: " .. IG_SAYCHANNEL .. " When Allone\n";
	IG_ChatMessage(text)
end
function IGuardStatus()
	local text = "- /IGuard |c00FFFFFFTo open this dialog.|r\n";
	local text = text .. "- /IGuard enable/disable |c00FFFFFFTo enable or disable IGuard Reports.|r\n";
	local text = text .. "- /IGuard helpme |c00FFFFFFTo disable/enable 'Help if Possible' in report.|r\n";
	local text = text .. "- /IGuard status |c00FFFFFFTo show current settings.|r\n";
	local text = text .. "- /IGuard recheck|c00FFFFFF if you Language is wrong use this command.|r\n";
	local text = text .. "- /IGuard reset |c00FFFFFFTo to reset channel settings.|r\n";
	if (IsAddOnLoaded("CT_RaidAssist") == 1) then
		IG_ChatMessage("- /IGuard CTRA |c00FFFFFFTo use /RS in Raid (Need Promoted or Leader to use).|r\n");
	else
		IG_ChatMessage("CTRA not found.\n");
	end
end
function ToggleIGuard(msg)
	if (msg == 0) then
		if (IGuardEnabled == true) then
			IGuardEnabled = false;
			IG_ChatMessage("Disabled.");
		else
			IG_ChatMessage("Already Disabled.");
		end
	elseif (msg == 1) then
		if (IGuardEnabled == true) then
			IG_ChatMessage("Already Enabled.");
		else
			IGuardEnabled = true;
			IG_ChatMessage("Enabled.");
		end
	end
end
function IG_HelpMe(msg)
	if (msg == 0) then
		if (IGHelpEnabled == true) then
			IGHelpEnabled = false;
			IG_ChatMessage("|c00FFFFFFHelp if Possible Disabled.|r\n");
		else
			IG_ChatMessage("Help Already Disabled.");
		end
	elseif (msg == 1) then
		if (IGHelpEnabled == false) then
			IGHelpEnabled = true;
			IG_ChatMessage("|c00FFFFFFHelp if Possible Enabled.|r\n");
		else
			IG_ChatMessage("Help already enabled");
		end
   
   end
end
function IG_CTRA()
	if (IsAddOnLoaded("CT_RaidAssist") == 1) then
		if (IG_CTRA_ENABLE == false) then
			IG_CTRA_ENABLE = true;
			IG_ChatMessage("|c00FFFFFF/rs Reporting Enabled.|r\n");
		else
			IG_CTRA_ENABLE = false;
			IG_ChatMessage("|c00FFFFFF/rs Reporting Disabled.|r\n");   
		end
	else
		IG_ChatMessage("Install CT_RaidAssist to use this Command.\n");
	end
end